# cp

cp命令用于本地上传，KS3下载，KS3桶之间复制 对象（Object）

## 命令格式

```
./ks3util cp   { ks3_path | local_path }    { ks3_path | local_path  }  -f<fail_keys> -include<include_files> -exclude<don't include files>  -r <Use relative path> -p<last time failed multi parts>
```

## 使用示例

使用**cp**命令将本地文件上传至KS3，其中：

- local_path：本地文件路径。例如Linux系统文件路径`/localfolder/examplefile.txt`；Windows系统文件路径`D:\localfolder\examplefile.txt`。
- ks3_path：KS3文件路径，格式为`ks3://bucketname/objectKey`。例如`ks3://examplebucket/examplefile.txt`

### 复制(需要填写目标桶的相关AKSK和Endpoint

#### [目录多文件复制]

`复制`KS3桶中的内容到另一个拥有权限的桶路径下 同时过滤掉某些特定文件

```
  ./ks3util cp ks3://bucketName1/path1/ ks3://bucketName2/path2/ -f false.txt -include *.pdf
  
  复制方式一:
  ----------校复制目标信息----------
  【Copy】 objectKey moved: path2/path1/
  【Copy】 objectKey moved: path2/path1/a
  【Copy】 objectKey moved: path2/path1/b
  【Copy】 objectKey moved: path2/path1/c
  【Copy】 Move done,totalKeys=4,failKeys=0
  All files copy over,totalKeys=4,filterFetchNum=0,SuccessTotalNum=4,repeatNum=0,failedNum=0
```

```：
  ./ks3util cp ks3://bucketName1/path1/* ks3://bucketName2/path2/ -f false.txt -include *.pdf
  
  复制方式二:
  ----------校验复制目标信息----------
  【Copy】 objectKey moved: path2/
  【Copy】 objectKey moved: path2/a
  【Copy】 objectKey moved: path2/b
  【Copy】 objectKey moved: path2/c
  【Copy】 Move done,totalKeys=4,failKeys=0
  All files copy over,totalKeys=4,filterFetchNum=0,SuccessTotalNum=4,repeatNum=0,failedNum=0
```

#### [单文件复制]

- 复制单个文件到目标桶下 （可以修改文件名存储） （原文件名存储）下载KS3云中到文件 如：bucket1 桶下 key为 **"sample/test.txt"** 的文件 到目的桶 **bucket2** 下以 原文件名称存储
  路径为 **"destPrefix/"**

```
./ks3util cp ks3://bucket1/sample/test.txt ks3://bucket2/destPrefix/ -f false.txt 
复制
【Copy】 DONE,totalKeys=1,SuccessTotalNum=0,filterFetchNum=0,repeatNum=1,failedNum=0
```

（修改文件名存储）下载KS3云中到文件 如：bucket1 桶下 key为 **"sample/test.txt"** 的文件 到目的桶 **bucket2** 下以 key为 **"destPrefix/1.txt"**  文件名存储

```jsunicoderegexp
./ks3util cp ks3://bucket1/sample/test.txt ks3://bucket2/destPrefix/1.txt -f false.txt

复制
【Copy】 DONE,totalKeys=1,SuccessTotalNum=0,filterFetchNum=0,repeatNum=1,failedNum=0
```

### 下载

#### [多文件下载]

下载KS3桶路径下的文件本地路径文件夹下内容 失败的文件写入false.txt文本中 可设置过滤条件(如只下载以.pdf结尾的文件)

  ``` {#codeblock_tzz_thx_qmu}
# 以下四种形式均可完成指定文件夹下载操作（文件夹路径结尾是否加斜杠均可）：
# 其中ks3目录不以斜杠结尾时，为带本身文件夹下载
-  ./ks3util cp ks3://bucketName/Path  LocalPath/  -f false.txt -include *.pdf
-  ./ks3util cp ks3://bucketName/Path  LocalPath   -f false.txt -include *.pdf

# ks3目录以斜杠结尾时，不带本身文件夹下载
-  ./ks3util cp ks3://bucketName/Path/ LocalPath/  -f false.txt -include *.pdf
-  ./ks3util cp ks3://bucketName/Path/ LocalPath   -f false.txt -include *.pdf
# 下载中遇到已存在的同名文件进行重新下载操作（配合 -u 参数 填写类型为 3 ，具体参数使用详见下文）
-  ./ks3util cp ks3://bucketName/Path/ LocalPath/  -f false.txt -u 3
  ```

- [单文件下载] 下载单个文件到本地 可以修改文件名存储 （原文件名存储）下载KS3云中到文件 如：bucket 桶下 key为 **"sample/test.txt"** 的文件 到本地目录 **"/Users/xxx/"**
  下以原key值存储 则下载下来的文件全路径为 **/Users/xxx/sample/test.txt**

```jsunicoderegexp
./ks3util cp ks3://bucket/sample/test.txt /Users/xxx/ -f false.txt 

下载
【Download】File write to /Users/xxx/sample/test.txt
```

（修改文件名存储）下载KS3云中到文件 如：bucket 桶下 key为 **"sample/test.txt"** 的文件 到本地目录 **"/Users/xxx/"** 下以 **1.conf**  文件名存储
则下载下来的文件全路径为 **/Users/xxx/1.conf**

```jsunicoderegexp
./ks3util cp ks3://bucket/sample/test.txt /Users/xxx/1.conf -f false.txt 

下载
【Download】File write to /Users/xxx/1.conf
```

### 上传

#### [多文件上传]

上传本地路径文件夹 **LocalPath **下内容到KS3桶 **bucketName** 的 **Path/** 路径下 失败的文件写入false.txt文本中 同时可设置过滤条件(如不下载以**.mp4**结尾的文件)

命令格式

```
以下四种形式均可完成指定文件夹上传操作（文件夹路径结尾是否加斜杠均可）：
-  ./ks3util cp LocalPath/  ks3://bucketName/Path -f false.txt -exclude *.mp4
-  ./ks3util cp LocalPath/  ks3://bucketName/Path/ -f false.txt -exclude *.mp4
-  ./ks3util cp LocalPath  ks3://bucketName/Path -f false.txt -exclude *.mp4
-  ./ks3util cp LocalPath  ks3://bucketName/Path/ -f false.txt -exclude *.mp4
# 上传中跳过目标路径下已存在的同名文件（配合 -u 参数，具体参数使用详见下文）
-  ./ks3util cp LocalPath/  ks3://bucketName/Path/ -f false.txt -u 3
```

#### [单文件上传]

上传本地路径单文件，如路径 **LocalPath**下的 **sample.txt**文件 到KS3桶 **bucektName** 路径下 重命名或者原名称存储
(修改文件名存储) 上传本地文件  **LocalPath/sample.txt** 到KS3桶 **bucket** 桶下 key为 **"sample/test.txt"** 的文件存储

``` 
以下形式均可完成指定单文件上传操作：    （生成目标桶文件为 bucketName/sample/test.txt）
 ./ks3util cp LocalPath/sample.txt  ks3://bucketName/sample/test.txt -f false.txt  
 ./ks3util cp LocalPath/sample.txt  ks3://bucketName/sample/ 				 -f false.txt
上传
【Upload】 SUCCESS sample/test.txt【success:1/total:1】
【Upload】 DONE,totalKeys=1,filterFetchNum=0,SuccessTotalNum=1,repeatNum=0,failedNum=0 cost=682
```

(原文件名存储) 上传本地文件  **LocalPath/sample.txt** 到KS3桶 **bucket** 桶下 以文件原名：key为 **"prefix/sample.txt"** 的文件存储

```jsunicoderegexp
./ks3util cp LocalPath/sample.txt ks3://bucket/prefix/ -f false.txt

上传
【Upload】 SUCCESS prefix/sample.txt【success:1/total:1】
【Upload】 DONE,totalKeys=1,filterFetchNum=0,SuccessTotalNum=1,repeatNum=0,failedNum=0 cost=686
```

- （使用相对路径上传文件） 使用当前执行命令的相对路径上传文件：使用 **"-r"** 参数 实例：当前执行命令的路径为 `/Users/xxx/ks3util-1.1.5/` 上传路径下文件夹`bin`中所有文件（使用相对路径）
  到桶名为`bucketName`路径下`test`文件夹中：

``` {#codeblock_vy0_qp2_0xu}
  ./bin/ks3util cp /bin  ks3://bucketName/test/ -f false.txt -r yes
  
------------初始化中------------
上传
All files upload over,totalKeys=12,filterFetchNum=0,SuccessTotalNum=12,repeatNum=0,failedNum=0 cost=5203
```

- （不使用相对路径上传文件）： 实例：当前执行命令的路径为 `/Users/xxx/ks3util-1.1.5/` 上传路径下文件夹`bin`中所有文件（使用绝对路径） 到桶名为`bucketName`路径下`test`文件夹中：

``` {#codeblock_vy0_qp2_0xu}
  ./bin/ks3util cp /Users/xxx/ks3util-1.1.5/bin  ks3://bucketName/test/ -f false.txt 
  
------------初始化中------------
上传
All files upload over,totalKeys=12,filterFetchNum=0,SuccessTotalNum=12,repeatNum=0,failedNum=0 cost=5203
```

### 对于已存在文件的更新操作：

使用参数 -u 进行判断： 若不填写则默认为 "u=0" 即根据文件最后修改时间逻辑 -u 参数填写规则：可以填写0～3 对应4种模式 0：根据文件最终修改时间判断：若源文件最后修改时间大于目标文件最终修改时间，则覆盖重传，
1：根据文件最终修改时间和文件大小统一判断：若源文件最后修改时间大于目标文件最终修改时间，或文件大小不一致 则覆盖重传 2：同名文件全部覆盖重传 3：同名文件全部跳过

``` 
[根据最后修改时间判断]上传，下载，复制文件  已经存在文件 根据最后修改时间判断是否重传
./ks3util cp { ks3_path | local_path }    { ks3_path | local_path  } -f false.txt -u 0
[根据修改时间和文件大小判断]上传，下载，复制文件  已经存在文件 根据修改时间和文件大小统一判断是否重传
./ks3util cp { ks3_path | local_path }    { ks3_path | local_path  } -f false.txt -u 1
[全部覆盖]上传，下载，复制文件  针对过程中已经存在文件 进行全部重传
./ks3util cp { ks3_path | local_path }    { ks3_path | local_path  } -f false.txt -u 2
[跳过]上传，下载，复制文件  针对过程中已经存在文件 进行全部跳过
./ks3util cp { ks3_path | local_path }    { ks3_path | local_path  } -f false.txt -u 3
```

## 常用选项

您可以在使用cp命令时附加如下选项指定列举模式及列举的内容：

| 选项名称  | 描述                                                        |是否必填 |
| --------- | -----------------------------------------------------------|--------- |
| `-f`      | 导出传输失败的objectKey列表文件                             |是|
| `-a`      | 文件的权限，值：Private/ PublicRead                       |否|
| `-p`      | 继续执行上次迁移分块上传失败文件                             |否|
| `-r`      | 是否使用当前相对路径 值：yes/ no（不区分大小写） 默认为no    |否|
| `-u`| 针对已经存在文件迁移逻辑判断 0=根据最后修改时间判断是否重传，1=最后修改时间和文件大小判断是否重传，2=全部重传，3=全部跳过                         |否|
| `-include`| 文件名称白名单，多个用英文逗号分隔。                         |否|
| `-exclude`| 文件名称黑名单，多个用英文逗号分隔。                         |否|




