# rm {#concept_303804 .concept}

rm命令用于删除存储空间 桶（Bucket）、对象（Object）。 支持过滤操作

## 命令格式 {#section_22j_0g5_zxr .section}

``` {#codeblock_iqe_41b_uc4}
./ks3util rm  ks3://bucket[/prefix]] [-f] [-b] [-r] [-include] [-exclude]
```

## 使用示例 {#section_qz8_3f3_3pp .section}

- 删除指定Bucket下指定的object

  ``` {#codeblock_tzz_thx_qmu}
  ./ks3util rm ks3://bucket1/Path/key
  
  delete successed :Path/key
  find 1 object, deleted 1 object,cost 442 ms
  finish multi-del command,totalKeys=1,filter Intercepts=0, failKeys=0 ,Check log for more information     
  ```


- 删除指定Bucket下某目录中所有文件

  ``` {#codeblock_tzz_thx_qmu}
  ./ks3util rm ks3://bucket1/dir/ 
  
  delete successed :dir/1
  delete successed :dir/2
  delete successed :dir/3
  delete successed :dir/4
  delete successed :dir/5
  find 38 object, deleted 38 object,cost 643 ms
  finish multi-del command,totalKeys=38,filter Intercepts=0, failKeys=0 ,Check log for more information
  ```

- 删除空的Bucket

  ``` {#codeblock_vy0_qp2_0xu}
  ./ks3util rm ks3://bucket/ -b
  
  deleteBucket  finish
                    
  ```

## 常用选项 {#section_u0p_bn4_loi .section}

您可以在使用`rm`命令时附加如下选项指定列举模式及列举的内容：

| 选项名称  | 描述                            |是否必填|
| --------- | ------------------------------------------------------------ |--------- |
| `-b`      | 删除一个空桶 （非空会报错）       |否|
| `-r`      | 失败重试次数                       |否 |
| `-f`      | 输入该值时会导出一份objectKey列表文件       |是|
| `-include` | 文件名称白名单，多个用英文逗号分隔。           |否|
| `-exclude` | 文件名称黑名单，多个用英文逗号分隔。 |否|




